unit M33Class;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

{ tahle knihovna obsahuje definice trid, ktere pouziji vsude jinde }

const
  DobreZnaky   : String = '؊ݎ';
   { seznam spec. znaku, co muzou byt ve slovech }

type
  TPozice = record { pozice v souboru }
    Radka,Index     : Integer;
  end;

  TSlovnik = class
  private

    FPozice             : TPozice; { pozice ve vstupnim souboru; radka a index v retezci }

    function IncPoz : boolean; { pricte k pozici jedna; vrati, jestli musel na dalsi radku }
    function DobryZnak(Co : Char) : Boolean; { je to znak, ktery se muze vyskytnout ve slove? }
    function AktZnak : Char; { vrati aktualni znak }

    function GetKonec : Boolean; { uz jsem na konci? }
    function MyLowerCase(Co : String) : String; { lowercase pro hacky a carky }
  public
    Slova,Inp           : TStringList; { SLOVA: seznam slov ve slovniku; INP: vstupni text }
    SlovPoz             : TPozice; { zacatek aktualniho slova }
    AktSlov             : String;

    property Pozice : TPozice read FPozice; 
    property Konec : Boolean read GetKonec; { jestli uz jsem na konci }

    procedure NactiSlova(FileName : String); { nacte slova ze souboru }
    procedure NactiVstup(FileName : String); { nacte vstupni soubor }
    procedure Zacatek; { presune pozici na zacatek }
    procedure SetPozice(Rad,Ind:Integer);

    function DalsiSlovo : String; { dostanu dalsi slovo a do SlovPoz dostanu
     zacatek toho slova a do Pozice konec slova+1; samotne slovo taky dostanu do AktSlov }
    function Kontrola(Slovo : String) : Boolean; { samotna kontrola }

    procedure PodobnaSlova(Slovo : String; Kam : TStrings);
     { vrati seznam podobnych slov }

    constructor Create;
    destructor Destroy; override;
  end;

implementation

       { TSlovnik }
constructor TSlovnik.Create;
begin
  inherited;
  Slova := TStringList.create;
  Inp := TStringList.create;
end;

destructor TSlovnik.Destroy;
begin
  inherited;
  Slova.Free;
  Inp.free;
end;

function TSlovnik.GetKonec : Boolean;
begin
  Result := (fpozice.Radka>inp.Count-1) or ((fpozice.Radka=inp.Count-1) and
   (fpozice.Index>length(inp.strings[inp.count-1])));
end;

function TSlovnik.IncPoz : Boolean;
begin
  if Konec then exit;
  result := false;
  if fpozice.Index<length(inp.Strings[fpozice.radka]) then inc(fpozice.index) else
   begin
    inc(fpozice.radka);
    fpozice.index := 1;
    result := true;
    while (not konec) and (length(inp.Strings[fpozice.radka])=0) do
     begin { musim na dalsi radku(pripadne radky, pokud jsou prazdne) }
      inc(fpozice.radka);
     end;
   end;  
end;

function TSlovnik.DobryZnak(Co : Char) : Boolean;
begin
  if (upcase(co)>='A') and (upcase(co)<='Z') then begin result := true; exit; end;
   { nejdriv provadim rychlou podminku na nejpouzivanejsi znaky, pak pomale hledani }
  result := pos(Co,DobreZnaky)<>0;
end;

function TSlovnik.AktZnak : Char;
begin
  if not konec then result := inp.strings[fpozice.radka][fpozice.index];
end;

function TSlovnik.MyLowerCase(Co : String) : String;
var
  pom     : string; { pomocny string }
  n,m     : integer; { cykly }

begin
  pom := LowerCase(co); { nejdriv udelam normalni LowerCase }
  for n := 1 to length(pom) do
   begin
    m := pos(pom[n],DobreZnaky);
    if (m <= 14) and (m <> 0) then pom[n] := DobreZnaky[m+14];
   end;
  result := pom;
end;

procedure TSlovnik.Zacatek;
begin
  SetPozice(0,1);
end;

procedure TSlovnik.SetPozice(Rad,Ind:Integer);
begin
  FPozice.Radka := Rad; FPozice.Index := Ind;
end;

function TSlovnik.DalsiSlovo : String;
var
  poz    : tpozice; { pomocna pozice }
  skok   : boolean;
  Slov   : string;

begin

  result := '';
  while (not konec) and (not DobryZnak(AktZnak)) do IncPoz;
   { tohle je dobra podminka; prelozeno: dokud nenajdu zacatek slova, tak jdi dal }
  if konec then exit;
  SlovPoz := FPozice; { zacatek slova ulozim }
  skok := false;
  slov := '';
  while (not konec) and (DobryZnak(AktZnak)) and (not skok) do
   begin
    slov := slov+AktZnak; { pridam znak }
    skok := IncPoz; { pokud jsem sel na dalsi radku, dostanu true a koncim }
   end;
  result := slov;
  aktslov := slov;

end;

procedure TSlovnik.NactiSlova(FileName : String);
var
  n     : integer;  { promenna do cyklu }
  s     : string; { pomocny }

begin
  Slova.LoadFromFile(FileName);
  for n := 0 to slova.count-1 do
   begin
    s := MyLowerCase(slova.strings[n]);
    if pos('/',s)<>0 then s := copy(s,1,pos('/',s)-1);
    slova.strings[n] := s;
    { smazu ze slov vse za lomitkem vcetne lomitka a prevedu na mala pismena }
   end;
  Slova.Sorted := True;
  { nastavim seznam slov tak, aby byl neustale serazeny
   podle abecedy. Z toho plyne vyhoda pri vyhledavani: Lze pouzit binarni vyhledavani }
end;

procedure TSlovnik.Nactivstup(FileName : String);
begin
  Inp.LoadFromFile(FileName);
  Zacatek;
end;

function TSlovnik.Kontrola(Slovo : String) : Boolean;
var poz : integer; { pomocna }
begin

  result := slova.Find(MyLowerCase(slovo),poz);
   { vzhledem k tomu, ze metoda FIND hleda v usporadanem seznamu binarni metodou,
    je to nadMru(?) efektivni }

end;

procedure TSlovnik.PodobnaSlova(Slovo : String; Kam : TStrings);
var
  n,m      : integer;

const
  maxslov  = 100;

 function JePodobne(Sl1,Sl2 : String) : Boolean;
 var
   vaha,n,pism      : integer; { tohle bude "vaha podobnosti", cim mensi, tim lepsi }

  const
    maxvaha  = 10; { maximalni vaha, aby to jeste bylo podobne }

 begin { urci, zda jsou si podobne }

  { vyhazuje to uplny kraviny }

   if (sl1='') or (sl2='') then exit;

   vaha := 15; { nekolik genialnich testu ... }
   inc(vaha,sqr(abs(length(sl1)-length(sl2))));
   for n := 1 to length(sl1)-1 do
    if pos(copy(sl1,n,2),sl2)<>0 then dec(vaha,1);
   for n := 1 to length(sl2)-1 do
    if pos(copy(sl2,n,2),sl1)<>0 then dec(vaha,1);

   if pos(sl1,sl2)<>0 then dec(vaha,length(sl1));
   if pos(sl2,sl1)<>0 then dec(vaha,length(sl2));

   pism := 0;
   for n := 1 to length(sl1) do if pos(sl1[n],sl2)<>0 then inc(pism);
   for n := 1 to length(sl2) do if pos(sl2[n],sl1)<>0 then inc(pism);
   if pism > length(sl1) then dec(vaha,pism-length(sl1));

   result := vaha<=maxvaha;

 end;

begin

  kam.Clear;
  for n := 0 to Slova.count-1 do
   begin
    if JePodobne(MyLowerCase(Slovo),Slova.Strings[n]) then
     kam.add(slova.strings[n]);
    if kam.count > maxslov then break;
   end;

end;

end.
