unit M33Thread;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  M33Class;

{ zde bude samostatny thread, ktery bude zpracovat slovnik. Okno aplikace
  tedy nebude "zamrzle" po dobu kontroly }

type
  TSlovnikThread = class(TThread)
  private
    { Private declarations }
    Slovnik        : TSlovnik;
    Vystup         : TStringList;
  protected
    procedure UpdateStav;
    procedure SendMess;
    procedure Execute; override;
  public
    Auto            : Boolean;  { pojedeme automaticky(z prik. radky?) }
    FileIn,FileOut  : String;  { soubory }
    podobna         : tstringlist; { podobna slova }

    constructor Create(Slov : TSlovnik; Vyst : TStringList; Aut : Boolean);
    destructor Destroy; override;
  end;

implementation
uses m33main;

       { TSlovnikThread }
constructor TSlovnikThread.Create(Slov : TSlovnik; Vyst : TStringList; Aut : Boolean);
begin

  inherited Create(True); { zalozim se Suspendovanej, abych mel kontrolu
   nad threadem na zacatku(parametry) }
  Auto := Aut; 
  Slovnik := Slov; { nastavim si adresu slovniku }
  if not aut then Vystup := Vyst else Vystup := TStringList.create;
   { pokud jedu automaticky, tak si to zalozi sam ten thread }
  podobna := tstringlist.create;

end;

destructor TSlovnikThread.Destroy;
begin
  inherited;
  podobna.free;
end;

procedure TSlovnikThread.UpdateStav;
begin
  mainform.pozlabel.caption := 'dka: '+inttostr(slovnik.pozice.radka)+'/'+
   inttostr(slovnik.inp.count);
end;

procedure TSlovnikThread.SendMess;
begin
  mainform.MojeZprava;
end;

procedure TSlovnikThread.Execute;
var
  sl                  : string; { slovo; pomocne }
  radka,xplus         : integer; { posledni zpracovavana radka; o kolik se to uz posunulo(pridani znaku #) }
  stop                : boolean;

begin
  { Place thread code here }

  if Auto then
   begin { jedu z prikazove radky }
    slovnik.NactiVstup(FileIn);
    vystup.Assign(slovnik.inp); { dam do vystupu zatim vstup }

    radka := 0; xplus := 0;
    while (not Terminated) and (not slovnik.konec) do
     begin
      sl := slovnik.DalsiSlovo;
      if slovnik.konec then break; { uz je konec }

      if slovnik.SlovPoz.radka <> radka then
       begin { jsme na dalsi radce -> posun uz neni }
        xplus := 0;
        radka := slovnik.slovpoz.radka;
        if radka mod 10 = 0 then Synchronize(UpdateStav);
       end;
      if not slovnik.Kontrola(sl) then
       begin
        vystup.strings[radka] := copy(vystup.strings[radka],1,slovnik.slovpoz.Index-1+xplus)+'#'+
         copy(vystup.strings[radka],slovnik.slovpoz.Index+xplus,length(vystup.strings[radka]));
        inc(xplus);
       end;
     end;
    try
      Vystup.SaveToFile(FileOut);
    except showmessage('Nelze ulozit soubor');
     { pokud to pustite z prostredi Delphi, tak to hodi exception, ale
       klavesa F9 to pusti dal. Za normalniho behu se to osetri v pohode }
    end;
    Vystup.Free;
   end else
    begin
     { soubor uz je nactenej, takze jedu }
     { telo bude tvorit smycka, ktera skonci az pri ukonceni programu; pouze
       bude dostavat prikazy; jakmile je vykona(najde chybu nebo dojede na konec),
       da sam sobe SUSPEND(uspi se) a ceka na RESUME } 
      while not terminated do
       begin
        stop := false;
        while (not slovnik.konec) and (not stop) do
         begin
          sl := slovnik.DalsiSlovo;
          if slovnik.konec then break; { uz je konec }

          if slovnik.SlovPoz.radka <> radka then
           begin { jsme na dalsi radce -> posun uz neni }
            xplus := 0;
            radka := slovnik.slovpoz.radka;
            Synchronize(UpdateStav);
           end;
          if not slovnik.Kontrola(sl) then
           begin
            stop := true;
            if mainform.podobbox.checked then
             slovnik.PodobnaSlova(slovnik.aktslov,podobna);
           end;
         end;
        SendMess;
        Suspend; { uz jsem udelal, co jsem mel }
       end;
    end;

end;

end.
